program ADOAdmin;

uses
  Windows,
  Sysutils,
  Forms,
  NZCSadoConst, NZCSComline,
  main in 'main.pas' {FrmADOAdmin},
  adoprop in 'adoprop.pas' {FrmADOProp},
  adoabout in 'adoabout.pas' {AboutBox};

{$R *.RES}

var
  hPrevious    : THandle;
  aAtom        : TAtom;

function EnumWindowsFunc(Handle: HWND; Param: LParam): boolean; stdcall;

  {---------------------------------------}
  function IsAPrevInstanceRunning: boolean;
  var
    ClassName : array[0..30] of Char;
    iAppID    : integer;
  begin

    { get the class name for the top-level window specified by Handle }
    GetClassName(Handle, ClassName, 30);

    { get the APP_ID for the application where the top-level window specified by Handle belongs }
    iAppID := SendMessage(Handle, UM_APP_ID_CHECK, 0, 0);

    { if ClassName matches to the this application's Main Form class name...}
    { and iAppID matches to to the this application's APP_ID}
    Result :=  (StrIComp(ClassName, ADOAdmin_Class) = 0) and (iAppID = ADOAdmin_AppId);
  end;
  {---------------------------------------}

begin
  { must be True to continue the enumeration }
  Result := not IsAPrevInstanceRunning;
  if not Result then hPrevious := Handle;
end;

procedure PassParamsToPreviousInstance;
begin
  PostMessage(hPrevious, UM_RESTORE_APPLICATION, 0, 0);
  if (sParams <> '') then
  begin
    aAtom := GlobalAddAtom(PChar(sParams));
    if aAtom = 0
    then RaiseLastWin32Error
    else
      begin
        SendMessage(hPrevious, UM_PREVIOUS_INST_PARAMS, aAtom, 0);
        GlobalDeleteAtom(aAtom);
      end;
  end;
end;

begin
  hPrevious := 0;
  aAtom     := 0;
  EnumWindows(@EnumWindowsFunc, 0);
  sParams := '';
  sParams := GetCommandLine; 
  { if a previous instance is already running then pass the command line
    parameters to it and exit... }
  if hPrevious <> 0
  then
    begin
      PassParamsToPreviousInstance;
      Exit;
    end
  else
  begin
     Application.Initialize;
     Application.Title := 'ADO Admin';
     Application.HelpFile := 'Adoadmin.hlp';
     Application.CreateForm(TFrmADOAdmin, FrmADOAdmin);
     Application.Run;
  end;
end.
