unit adoabout;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TAboutBox = class(TForm)
    OKButton: TButton;
    ProgramIcon: TImage;
    ProductName: TLabel;
    lbVersion: TLabel;
    Copyright: TLabel;
    lblurl: TLabel;
    Bevel1: TBevel;
    lblMem: TLabel;
    lblOS: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure lblurlClick(Sender: TObject);
  private
    procedure ReadVersionInfo;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

uses shellapi;

{$R *.DFM}

Function GetOSInfo: String;
var
  Platform: string;
  BuildNumber: Integer;
begin
  case Win32Platform of
    VER_PLATFORM_WIN32_WINDOWS:
      begin
        Platform := 'Windows 95';
        BuildNumber := Win32BuildNumber and $0000FFFF;
      end;
    VER_PLATFORM_WIN32_NT:
      begin
        Platform := 'Windows NT';
        BuildNumber := Win32BuildNumber;
      end;
      else
      begin
        Platform := 'Windows';
        BuildNumber := 0;
      end;
  end;
  if (Win32Platform = VER_PLATFORM_WIN32_WINDOWS) or
    (Win32Platform = VER_PLATFORM_WIN32_NT) then
  begin
    if Win32CSDVersion = '' then
      Result := Format('%s %d.%d (Build %d)', [Platform, Win32MajorVersion,
        Win32MinorVersion, BuildNumber])
    else
      Result := Format('%s %d.%d (Build %d: %s)', [Platform, Win32MajorVersion,
        Win32MinorVersion, BuildNumber, Win32CSDVersion]);
  end
  else
    Result := Format('%s %d.%d', [Platform, Win32MajorVersion,
      Win32MinorVersion])
end;

procedure TAboutBox.FormCreate(Sender: TObject);
var
   MS: TMemoryStatus;
begin
   lblOS.Caption := GetOSInfo;
   MS.dwLength := SizeOf(TMemoryStatus);
   GlobalMemoryStatus(MS);
   lblMem.Caption := 'Memory Available to Windows: ' + FormatFloat('#,###" KB"', MS.dwTotalPhys div 1024);
   ReadVersionInfo;
end;

procedure TAboutBox.ReadVersionInfo;
var
   versionHandle, versionSize : DWord;
   pVersionInfo : pointer;
   itemLen : UInt;
   FixedFileInfo : PVSFixedFileInfo;
   TempStr: String;
begin
   versionSize := GetFileVersionInfoSize(PChar(Application.ExeName), versionHandle);
   if versionSize = 0 then
      exit;
   getMem(pVersionInfo, versionSize);
   try
      if GetFileVersionInfo(PChar(Application.ExeName), versionHandle, versionSize, pVersionInfo) then begin
         //DecodeVersionInfo(pVersionInfo);
	 if VerQueryValue(pVersionInfo, '\', Pointer(FixedFileInfo), itemLen) then begin
            TempStr := IntToStr(HIWORD(FixedFileInfo^.dwFileVersionMS)) +
	               '.' + IntToStr(LOWORD(FixedFileInfo^.dwFileVersionMS)) +
		       '.' +	IntToStr(HIWORD(FixedFileInfo^.dwFileVersionLS)) +
		       '.' + IntToStr(LOWORD(FixedFileInfo^.dwFileVersionLS));

            while ((copy(TempStr, length(TempStr), 1)='0') or (copy(TempStr, length(TempStr), 1)='.')) do
     	        TempStr := copy(TempStr, 1, length(TempStr)-1);
            if (Pos('.', TempStr)<=0) Then
               TempStr := TempStr + '.0';
            lbVersion.caption := 'Version ' + TempStr;
         end;
      end;
   finally
      freeMem(pVersionInfo, versionSize);
   end;
end;


procedure TAboutBox.lblurlClick(Sender: TObject);
var
  zFileName: array[0..150] of Char;
begin
   ShellExecute(Handle, nil,StrPCopy(zFileName, lblurl.Caption), nil, nil, 1);
end;

end.

