unit adoprop;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls;

type                             
  TFrmADOProp = class(TForm)
    PageControl1: TPageControl;
    TSGeneral: TTabSheet;
    SourceofConnection: TGroupBox;
    UseDataLinkFile: TRadioButton;
    DataLinkFile: TComboBox;
    Browse: TButton;
    UseConnectionString: TRadioButton;
    ConnectionString: TEdit;
    Build: TButton;
    Label1: TLabel;
    PStats: TPanel;
    EbAlias: TEdit;
    Label2: TLabel;
    EbDesc: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    EbApplication: TEdit;
    EbCustom1: TEdit;
    EbCustom2: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure EbAliasKeyPress(Sender: TObject; var Key: Char);
    procedure BrowseClick(Sender: TObject);
    procedure BuildClick(Sender: TObject);
    procedure UseConnectionStringClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    Cancelled: Boolean;
  end;

var
  FrmADOProp: TFrmADOProp;

implementation

uses ADODB, NZCSFunct, NZCSADOIni;

{$R *.DFM}

procedure TFrmADOProp.EbAliasKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = #13 then begin
      PostMessage(FrmADOProp.Handle, WM_NEXTDLGCTL, 0, 0);
      Key := #0;
   end;
end;

procedure TFrmADOProp.BrowseClick(Sender: TObject);
begin
  DataLinkFile.Text := PromptDataLinkFile(Handle, DataLinkFile.Text);
end;

procedure TFrmADOProp.BuildClick(Sender: TObject);
begin
  ConnectionString.Text := PromptDataSource(Handle, ConnectionString.Text);
end;

procedure TFrmADOProp.UseConnectionStringClick(Sender: TObject);
const
  EnabledColor: array[Boolean] of TColor = (clBtnFace, clWindow);
begin
  DataLinkFile.Enabled := UseDataLinkFile.Checked;
  DataLinkFile.Color := EnabledColor[DataLinkFile.Enabled];
  Browse.Enabled := DataLinkFile.Enabled;
  ConnectionString.Enabled := UseConnectionString.Checked;
  ConnectionString.Color := EnabledColor[ConnectionString.Enabled];
  Build.Enabled := ConnectionString.Enabled;
  if Sender <> nil then begin
     if DataLinkFile.Enabled then
        ActiveControl := DataLinkFile
     else
        ActiveControl := ConnectionString;
  end;
end;

procedure TFrmADOProp.Button1Click(Sender: TObject);
var
   ConStr: String;
begin
   If EbAlias.text = '' then begin
      EbAlias.SetFocus;
      MsgWarn('Alias name is required');
   end;
   If (DataLinkFile.Text <> '') and UseDataLinkFile.Checked then begin
      ConStr := ReadUDL(DataLinkFile.Text);
      UseConnectionString.Checked := True;
      ConnectionString.text := ConStr;
   end;
   If ConnectionString.text = '' then begin
      MsgWarn('Connection string is required');
   end;
   Cancelled := False;
   close;
end;

procedure TFrmADOProp.FormCreate(Sender: TObject);
begin
   Cancelled := True;
end;

procedure TFrmADOProp.Button2Click(Sender: TObject);
begin
   Close;
end;

procedure TFrmADOProp.FormShow(Sender: TObject);
begin
   EbAlias.SetFocus;
end;

end.
