unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, ADODB, StdCtrls, ComCtrls, Menus,
  ExtCtrls, NZCSADOini, ImgList, Buttons, NZCSadoConst;


type
  TActionState = (asEdit, asInsert, asCopy, asPaste);

  TFrmADOAdmin = class(TForm)
    ADOConnection1: TADOConnection;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    StatusBar1: TPanel;
    TV: TTreeView;
    New1: TMenuItem;
    EditAlias1: TMenuItem;
    New2: TMenuItem;
    EditAlias2: TMenuItem;
    Actions1: TMenuItem;
    DeleteAlias1: TMenuItem;
    DeleteAlias2: TMenuItem;
    Copy1: TMenuItem;
    Open1: TMenuItem;
    Copy2: TMenuItem;
    OpenConnection2: TMenuItem;
    CloseConnection2: TMenuItem;
    SaveConfiguration1: TMenuItem;
    N1: TMenuItem;
    MergeConfiguration1: TMenuItem;
    ImgList: TImageList;
    OpenConnection1: TMenuItem;
    N2: TMenuItem;
    CloseConnection1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    Aboutthis1: TMenuItem;
    PopAction: TPopupMenu;
    OD: TOpenDialog;
    SD: TSaveDialog;
    LV: TListView;
    Whatsthis1: TMenuItem;
    CreateMicrosoftDataLinkFile2: TMenuItem;
    N4: TMenuItem;
    CreateMicrosoftDataLinkFile1: TMenuItem;
    N5: TMenuItem;
    Edit1: TMenuItem;
    Copy3: TMenuItem;
    Paste1: TMenuItem;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TVChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure LVDblClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure EditAlias1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure DeleteAlias1Click(Sender: TObject);
    procedure TVKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Actions1Click(Sender: TObject);
    procedure Aboutthis1Click(Sender: TObject);
    procedure OpenConnection1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveConfiguration1Click(Sender: TObject);
    procedure MergeConfiguration1Click(Sender: TObject);
    procedure CloseConnection1Click(Sender: TObject);
    procedure Whatsthis1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure CreateMicrosoftDataLinkFile2Click(Sender: TObject);
    procedure Copy3Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
  private
    ADOIniFile: TADOAlias;
    procedure LoadAlias(Alias: String);
    procedure LoadConnections;
    procedure Perform(ActionState: TActionState);
    procedure CloseConnection;
    procedure UMAppIDCheck(var Message : TMessage); message UM_APP_ID_CHECK;
    procedure UMRestoreApplication(var Message : TMessage); message UM_RESTORE_APPLICATION;
    procedure UMPreviousInstParams(var Message : TMessage); message UM_PREVIOUS_INST_PARAMS;
    procedure HandleParams;
    procedure MergeConfig(FN: TFilename);
    procedure InstallADOAdmin;
  public
    { Public declarations }
  end;

var
  FrmADOAdmin: TFrmADOAdmin;

implementation

uses NZCSFunct, NZCSComLine, adoprop, adoabout, OLEDB, ComObj, clipbrd;

{$R *.DFM}

procedure TFrmADOAdmin.Exit1Click(Sender: TObject);
begin
   Close;
end;

Procedure TFrmADOAdmin.LoadConnections;
var
   AliasList: TStringList;
   RootAlias,NewAlias: TTreeNode;
   i: Integer;
begin
   TV.Items.BeginUpdate;
   Try
      TV.Items.Clear;
      RootAlias := TV.Items.Add(nil, RootCaption);
      With ADOIniFile do begin
         AliasList := TStringList.Create;
         Try
            GetAliasList(AliasList);
            AliasList.Sort;
            for i := 0 to AliasList.Count - 1 do begin
               NewAlias := TV.Items.AddChild(RootAlias, AliasList[i]);
               NewAlias.ImageIndex := 1;
               NewAlias.StateIndex := 1;
               NewAlias.SelectedIndex := 1;
            end;
         finally
            AliasList.Free;
         end;
      end;
   finally
      TV.FullExpand;
      TV.Items.EndUpdate;
   end;
end;

procedure TFrmADOAdmin.LoadAlias(Alias: String);
var
   NewItem: TListItem;
   the_params: TStringList;
   i: Integer;
begin
   Try
      LV.Items.Clear;
      With ADOIniFile do begin
         the_params := TStringList.Create;
         Try
            GetParams(Alias, the_params);
            the_params.Sort;
            for i := 0 to the_params.Count - 1 do begin
               NewItem := LV.Items.Add;
               NewItem.Caption := the_params.Names[i];
               NewItem.SubItems.Add(the_params.Values[the_params.Names[i]]);
            end;
         finally
            the_params.Free;
         end;
      end;
   finally
   end;
end;

procedure TFrmADOAdmin.FormCreate(Sender: TObject);
var
   Fn: String;
begin
   SetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOAdminPath', AppPath);
   Fn := GetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOConfig');
   HandleParams;
   If not Assigned(ADOIniFile) then begin
      if (fn <> '') and FileExists(Fn) then
         ADOIniFile := TADOAlias.Create(fn)
      else
         ADOIniFile := TADOAlias.Create(AppPath + 'ADOConfig.dcs');
   end;
   FrmADOAdmin.Caption := 'ADO Admin - ' + ADOIniFile.Filename;
end;

procedure TFrmADOAdmin.TVChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
begin
    LoadAlias(Node.Text);
end;

procedure TFrmADOAdmin.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   SetRegStrValue(HKEY_CURRENT_USER,RegKey,'ADOConfig', ADOIniFile.Filename);
   ADOIniFile.Free;
end;

procedure TFrmADOAdmin.FormShow(Sender: TObject);
begin
   LoadConnections;
end;

procedure TFrmADOAdmin.LVDblClick(Sender: TObject);
begin
   Perform(asEdit);
end;

procedure TFrmADOAdmin.Perform(ActionState: TActionState);
var
   i: Integer;
begin
   if not Assigned(FrmADOProp) then
      FrmADOProp := TFrmADOProp.Create(self);
   With FrmADOProp do begin
      UseConnectionString.Checked := True;
      If (ActionState = asEdit) or (ActionState = asCopy) or (ActionState = asPaste) then begin
         if (ActionState = asEdit) then
            EbAlias.Text := TV.Selected.Text
         else
            ActionState := asInsert;
         EbDesc.Text := ADOIniFile.GetParamValue(TV.Selected.Text,'DESCRIPTION');
         EbApplication.Text := ADOIniFile.GetParamValue(TV.Selected.Text,'APPLICATION');
         EbCustom1.Text := ADOIniFile.GetParamValue(TV.Selected.Text,'CUSTOM1');
         EbCustom2.Text := ADOIniFile.GetParamValue(TV.Selected.Text,'CUSTOM2');
         If ActionState = asPaste then
            ConnectionString.PasteFromClipboard
         else
            ConnectionString.Text := ADOIniFile.GetConnectionStr(TV.Selected.Text);
      end;
      Showmodal;
      If not Cancelled then begin
         If (ActionState = asEdit) or (ActionState = asCopy) or (ActionState = asPaste) then begin
            ADOIniFile.AddAlias(EbAlias.Text, ConnectionString.Text, EbDesc.Text,
                             EbApplication.Text, EbCustom1.Text, EbCustom2.Text);
            ADOIniFile.UpdateFile;
            LoadConnections;
            For i := 0 to TV.Items.Count -1 do begin
               If SameText(Tv.Items[i].Text,EbAlias.Text) then begin
                  Tv.Selected := Tv.Items[i];
                  break;
               end;
            end;
         end
         else begin
            if EbAlias.Text <> TV.Selected.Text then begin
               ADOIniFile.RenameAlias(TV.Selected.Text ,EbAlias.Text);
               TV.Selected.Text := EbAlias.Text;
            end;
            ADOIniFile.ModifyAlias(EbAlias.Text, ConnectionString.Text, EbDesc.Text,
                             EbApplication.Text, EbCustom1.Text, EbCustom2.Text);
            ADOIniFile.UpdateFile;
         end;
         LoadAlias(EbAlias.Text);
      end;
   end;
   FrmADOProp.Free;
   FrmADOProp := nil;
end;

procedure TFrmADOAdmin.New1Click(Sender: TObject);
begin
   Perform(AsInsert);
end;

procedure TFrmADOAdmin.EditAlias1Click(Sender: TObject);
begin
   if assigned(TV.Selected) and (TV.Selected.Text <> RootCaption) then
      Perform(asEdit);
end;

procedure TFrmADOAdmin.Copy1Click(Sender: TObject);
begin
   if (TV.Selected.Text <> RootCaption) then
      Perform(AsCopy);
end;

procedure TFrmADOAdmin.DeleteAlias1Click(Sender: TObject);
var
   Node: TTreeNode;
   Alias: String;
begin
   If Assigned(TV.Selected) and (TV.Selected.Text <> RootCaption) and
      MsgYesNo(Format(DeleteString,[TV.Selected.Text])) then begin
      Alias := TV.Selected.Text;
      Node := TV.Selected;
      TV.Selected := TV.Selected.GetPrevVisible;
      Node.Delete;
      ADOIniFile.Delete(Alias);
      ADOIniFile.UpdateFile;
      LoadAlias(TV.Selected.Text);
   end;
end;

procedure TFrmADOAdmin.TVKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   If Key = vk_delete then begin
      If Assigned(TV.Selected) then
         DeleteAlias1Click(nil);
   end;
end;

procedure TFrmADOAdmin.Actions1Click(Sender: TObject);
var
   Enabl: Boolean;
begin
   Enabl := Assigned(TV.Selected) and (TV.Selected.Text <> RootCaption);
   Copy1.Enabled := Enabl;
   EditAlias1.Enabled := Enabl;
   DeleteAlias1.Enabled := Enabl;
   OpenConnection1.Enabled := Enabl;
   CloseConnection1.Enabled := Enabl;
   Copy2.Enabled := Enabl;
   EditAlias2.Enabled := Enabl;
   DeleteAlias2.Enabled := Enabl;
   OpenConnection2.Enabled := Enabl;
   CloseConnection2.Enabled := Enabl;
   CreateMicrosoftDataLinkFile1.Enabled := Enabl;
   CreateMicrosoftDataLinkFile2.Enabled := Enabl;
end;

procedure TFrmADOAdmin.Aboutthis1Click(Sender: TObject);
begin
   AboutBox := TAboutBox.Create(self);
   AboutBox.ShowModal;
   AboutBox.Free;
end;

procedure TFrmADOAdmin.OpenConnection1Click(Sender: TObject);
begin
   If ADOConnection1.Connected then begin
      CloseConnection;

   end;
   ADOConnection1.ConnectionString := ADOIniFile.GetConnectionStr(TV.Selected.Text);
   ADOConnection1.Connected := True;
   TV.Selected.ImageIndex := 2;
   TV.Selected.SelectedIndex := 2;
end;

procedure TFrmADOAdmin.CloseConnection;
var
   Node: TTreeNode;
   i: Integer;
begin
   ADOConnection1.Connected := False;
   For i := 0 to TV.Items.Count - 1 do begin
      Node := TV.Items[i];
      If (Node.text <> RootCaption) and (Node.ImageIndex <> 1) then begin
         Node.ImageIndex := 1;
         Node.SelectedIndex := 1;
      end;
   end;
end;
      
procedure TFrmADOAdmin.Open1Click(Sender: TObject);
var
   OldFileName: String;
begin
   If OD.Execute then begin
      If ExtractFileExt(OD.FileName) = '' then
         OD.FileName := ChangeFileExt(OD.FileName,'.dcs');
      OldFileName := ADOIniFile.FileName;
      ADOIniFile.Free;
      Try
         ADOIniFile := TADOAlias.Create(OD.FileName)
      except
         ADOIniFile := TADOAlias.Create(OldFileName);
         raise;
      end;
      FrmADOAdmin.Caption := 'ADO Admin - ' + ADOIniFile.Filename;
      LoadConnections;
   end;
end;

procedure TFrmADOAdmin.SaveConfiguration1Click(Sender: TObject);
begin
   SD.Filter := 'Data Connection Strings|*.dcs';
   If SD.Execute then begin
      If ExtractFileExt(SD.FileName) = '' then
         SD.FileName := ChangeFileExt(SD.FileName,'.dcs');
      ADOIniFile.Rename(SD.FileName,False);
      ADOIniFile.UpdateFile;
      SetRegStrValue(HKEY_CURRENT_USER,RegKey,'ADOConfig', ADOIniFile.Filename);
      FrmADOAdmin.Caption := 'ADO Admin - ' + ADOIniFile.Filename;
      LoadConnections;
   end;
end;

procedure TFrmADOAdmin.MergeConfiguration1Click(Sender: TObject);
begin
   If OD.Execute then begin
      If ExtractFileExt(OD.FileName) = '' then
         OD.FileName := ChangeFileExt(OD.FileName,'.dcs');
      MergeConfig(OD.FileName);
   end;
end;

procedure TFrmADOAdmin.MergeConfig(FN: TFilename);
var
   ADOAlias: TADOAlias;
   i: Integer;
   Alias: String;
begin
   ADOAlias := TADOAlias.Create(FN);
   Try
      For i := 0 to ADOAlias.AliasCount - 1 do begin
         Alias := ADOAlias.AliasName[i];
         if not ADOIniFile.Exists(Alias) then begin
            ADOIniFile.ModifyAlias(Alias,
                                   ADOAlias.GetConnectionStr(Alias),
                                   ADOAlias.ReadString(Alias,'Description',''),
                                   ADOAlias.ReadString(Alias,'Application',''),
                                   ADOAlias.ReadString(Alias,'Custom1',''),
                                   ADOAlias.ReadString(Alias,'Custom2',''));
         end;
      end;
   finally
      ADOIniFile.UpdateFile;
      LoadConnections;
      ADOAlias.Free;
   end;
end;

procedure TFrmADOAdmin.CloseConnection1Click(Sender: TObject);
begin
   CloseConnection;
end;

procedure TFrmADOAdmin.UMAppIDCheck(var Message: TMessage);
begin
   Message.Result := ADOAdmin_AppId;
end;

procedure TFrmADOAdmin.UMPreviousInstParams(var Message: TMessage);
var
   Len : integer;
   S   : string;
begin
   SetLength(S, MAX_PATH);
   Len := GlobalGetAtomName(Message.wParam, PChar(S), MAX_PATH);
   if Len = 0 then
      RaiseLastWin32Error
   else
   begin
      SetLength(S, Len);
      SParams := PChar(S);
      HandleParams;
   end;
end;

procedure TFrmADOAdmin.HandleParams;
var
   i: Integer;
   AlreadyRunning: Boolean;
   OldFileName: String;
begin
   // To access the params make sure you use the aParamStr and aParamCount because they
   // cope with the program already running
   AlreadyRunning := Assigned(ADOIniFile);
   For i := 1 to aParamCount - 1 do begin
      // Param 1 can be a config file //
      If (i = 1) and FileExists(aParamStr(1)) then begin
         If not AlreadyRunning then begin
            OldFileName := ADOIniFile.Filename;
            ADOIniFile.Free;
         end;
         Try
            ADOIniFile := TADOAlias.Create(OD.FileName)
         except
            if AlreadyRunning then
               ADOIniFile := TADOAlias.Create(OldFileName);
            raise;
         end;
         FrmADOAdmin.Caption := 'ADO Admin - ' + ADOIniFile.Filename;
         if AlreadyRunning then
            LoadConnections;
         Break;
      end;
      If aFindCmdLineSwitch('I',['-','/'],True) > -1 then begin
         InstallADOAdmin;
         break
      end;
   end;
end;

procedure TFrmADOAdmin.UMRestoreApplication(var Message: TMessage);
begin
   if IsIconic(Application.Handle) then
      Application.Restore
   else begin
      Application.BringToFront;
   end;
end;

procedure TFrmADOAdmin.Whatsthis1Click(Sender: TObject);
begin
   PostMessage (Handle, WM_SYSCOMMAND, SC_CONTEXTHELP, 0);
end;

procedure TFrmADOAdmin.InstallADOAdmin;
var
   Cnt: Smallint;
   fn, FnCurrent: string;
begin
   SetRegStrValue(HKEY_LOCAL_MACHINE, REGKey, 'ActiveX', 'FALSE');
   If aFindCmdLineSwitch('C',['-','/'],True) > -1 then
      SetRegStrValue(HKEY_LOCAL_MACHINE, REGKey, 'ActiveX', 'TRUE');
   SetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOAdminPath', AppPath);
   SetRegStrValue(HKEY_LOCAL_MACHINE,REGKey,'ADOAdminPath', AppPath);
   Cnt := aFindCmdLineSwitch('F',['-','/'],True) + 1;
   If cnt > 1 then begin
      Fn := aParamStr(cnt);
      FnCurrent := GetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOConfig');
      If FnCurrent = '' then
         FnCurrent := AppPath + 'ADOConfig.dcs';
      if not assigned(ADOIniFile) then
         ADOIniFile := TADOAlias.Create(FnCurrent);
      If not SameText(FN,ADOIniFile.FileName) then begin
         If FileExists(fn) then begin
            MergeConfig(fn);
            DeleteFile(fn);
         end;
      end;
   end;
   Application.Terminate;
end;

procedure TFrmADOAdmin.Contents1Click(Sender: TObject);
begin
   Application.HelpCommand(HELP_CONTENTS,0);
end;

procedure TFrmADOAdmin.CreateMicrosoftDataLinkFile2Click(Sender: TObject);
var
  ConnStr,Filenme: WideString;
  DataInit: IDataInitialize;
  SDInitialDir: String;
begin
   SD.Filter := 'Microsoft Data Link|*.udl';
   SDInitialDir := SD.InitialDir;
   SD.InitialDir := DataLinkDir;
   If SD.Execute then begin
      DataInit := CreateComObject(CLSID_DataLinks) as IDataInitialize;
      ConnStr := ADOIniFile.GetConnectionStr(TV.Selected.Text);
      Filenme := ChangeFileExt(SD.FileName,'.udl');
      OleCheck(DataInit.WriteStringToStorage(PWideChar(Filenme),PWideChar(ConnStr), CREATE_NEW));
   end;
   SD.InitialDir := SDInitialDir;
end;



procedure TFrmADOAdmin.Copy3Click(Sender: TObject);
begin
   if Assigned(TV.Selected) then
      ClipBoard.AsText := ADOIniFile.GetConnectionStr(TV.Selected.Text);
end;

procedure TFrmADOAdmin.Paste1Click(Sender: TObject);
begin
   Perform(AsPaste);
end;

end.
