unit ADOAdminCom;

interface

uses
  ComObj, ActiveX, ADOAdminX_TLB, StdVcl, NZCSADOini, windows, NZCSadoConst,
  Sysutils;

type
  TADOAdmin = class(TAutoObject, IADOAdmin)
  private
     ADOAlias: TADOAlias;
     Procedure OpenADOIni;
  protected
    procedure AddAlias(const Alias, ConnectionString, Description, AppName,
      Custom1, Custom2: WideString); safecall;
    procedure Delete(const Alias: WideString); safecall;
    function GetConnectionStr(const Alias: WideString): WideString; safecall;
    procedure ModifyAlias(const Alias, ConnectionString, Description, AppName,
      Custom1, Custom2: WideString); safecall;
    function Exists(const Alias: WideString): WordBool; safecall;
    function Get_Filename: WideString; safecall;
    procedure Set_Filename(const Value: WideString); safecall;
  end;

implementation

uses ComServ, NZCSFunct, FileCtrl, dialogs;

procedure TADOAdmin.AddAlias(const Alias, ConnectionString, Description,
  AppName, Custom1, Custom2: WideString);
begin
   OpenADOIni;
   Try
      ADOAlias.AddAlias(Alias, ConnectionString, Description, AppName,
                               Custom1, Custom2);
      ADOAlias.UpdateFile;
   finally
      ADOAlias.Free;
   end;
end;

Procedure TADOAdmin.OpenADOIni;
var
   fn: String;
begin
   Fn := GetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOConfig');
   If (Fn = '') or not FileExists(Fn) then begin
      Fn := ExtractFileDrive(FindWindowsDir) + 'Program Files\Common Files\ADOAdmin\';
      ForceDirectories(FN);
      FN := FN + 'ADOConfig.dcs';
      ADOAlias := TADOAlias.Create(fn);
      SetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOConfig', fn);
   end
   else
      ADOAlias := TADOAlias.Create(fn);
end;


procedure TADOAdmin.Delete(const Alias: WideString);
begin
   OpenADOIni;
   Try
      ADOAlias.Delete(Alias);
      ADOAlias.UpdateFile;
   finally
      ADOAlias.Free;
   end;
end;

function TADOAdmin.GetConnectionStr(const Alias: WideString): WideString;
begin
   OpenADOIni;
   Try
      result := ADOAlias.GetConnectionStr(Alias);
   finally
      ADOAlias.Free;
   end;
end;

procedure TADOAdmin.ModifyAlias(const Alias, ConnectionString, Description,
  AppName, Custom1, Custom2: WideString);
begin
   OpenADOIni;
   Try
      ADOAlias.ModifyAlias(Alias, ConnectionString, Description, AppName,
                               Custom1, Custom2);
      ADOAlias.UpdateFile;
   finally
      ADOAlias.Free;
   end;
end;

function TADOAdmin.Exists(const Alias: WideString): WordBool;
begin
   OpenADOIni;
   Try
      result := ADOAlias.Exists(Alias);
   finally
      ADOAlias.Free;
   end;
end;

function TADOAdmin.Get_Filename: WideString;
begin
   result := PWideChar(GetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOConfig'));
end;

procedure TADOAdmin.Set_Filename(const Value: WideString);
begin
// Nothing
end;

initialization
  TAutoObjectFactory.Create(ComServer, TADOAdmin, Class_ADOAdmin,
    ciMultiInstance, tmApartment);
end.
