library ADOcp;

//  Control Panel Template design was written by : Neil Jones (abton@operamail.com)

uses
  SysUtils,
  CPL,
  registry,
  Windows,
  Classes,
  NZCSadoConst;

{$E .cpl}

//  Include required resources (an icon and two strings)
//  See main.rc for more details
{$R main.res}

var
   CPLInfo : pCPLINFO;
   ThisInst, IconHandle : integer;

function GetRegStrValue(RootKeyType: HKEY; Key, Value: String): string;
var
   Registry: TRegistry;
begin
   Result := '';
   Registry := TRegistry.Create;
   try
      Registry.RootKey  := RootKeyType;
      if Registry.OpenKey(Key,False) then begin
         Result := Registry.ReadString(Value);
         Registry.CloseKey;
      end;
   finally
      Registry.Free;
   end;
end;

function FindWindowsDir :STRING;
var
   Buffer: PChar;
   Size: Word;
   x: integer;
   WinDir: string;
begin
   Size := 200;
   Inc(Size);
   GetMem(Buffer, Size);           {Creates Buffer dynamic variable}
   x := GetWindowsDirectory(Buffer, Size);
   WinDir := copy(StrPas(Buffer),1,x); {Converts Buffer to a Pascal-style STRING}
   if copy(windir,x - 1, x) <> '\' then
      windir := windir + '\';
   FreeMem(Buffer, Size); {Frees memory allocated to Buffer}
   result := windir;
end;

function BackSlash(Path: STRING): string;
begin
   Result := Path;
   if (Length(Path) >= 1) and (Path[1] <> '\') then
      Result := Path + '\';
end;

procedure StartProg(FileName: String);
var
   iRet: DWORD;
   Path: PChar;
   InstanceID: THandle;
    Msg: TMsg;
    bStat: BOOL;
    pi: TProcessInformation;
    si: TStartupInfo;
    iExit: DWORD;
    bExit: boolean;
    tmp: String;
begin
   path := pchar(FileName);
   try
   FillMemory( @si, sizeof( TStartupInfo ), 0 );
   with si do begin
      cb := sizeof( TStartupInfo );
      dwFlags := STARTF_USESHOWWINDOW;
      wShowWindow := SW_NORMAL;
   end;
   bStat := CreateProcess
    (
    nil,  // address of module name
    Path, // address of command line
    nil,  // address of process security attributes
    nil,  // address of thread security attributes
    false,  // new process inherits handles
    NORMAL_PRIORITY_CLASS   ,  // creation flags
    nil,  // address of new environment block
    nil,  // address of current directory name
    si, // address of STARTUPINFO
    pi  // address of PROCESS_INFORMATION
    );
  finally
  CloseHandle( pi.hProcess );
  CloseHandle( pi.hThread );
  end;
end;

//  The exported function MUST be declared like this!
function CPlApplet(hwndCPl: THandle; uMsg: DWORD;
                   lParam1, lParam2: Longint): Longint; stdcall;
var
   Path: String;
begin
     //  You MUST process these events
     case uMsg of
          //  CPL_INIT - Initialise the application.  Put your initialisation
          //  code here.
          CPL_INIT : begin
                          //  Use the name of your control panel applet here
                          ThisInst := GetModuleHandle('ADOcp.cpl');
                          //  Get a handle to our icon from main.res for use later
                          IconHandle := LoadIcon(ThisInst, 'APPLET_ICON');
                          //  Return nonzero to indicate success
                          result := 1;
                     end;
          //  CPL_GETCOUNT - Return the number of dialogs we have (only 1 in this case)
          CPL_GETCOUNT : result := 1;
          //  CPL_INQUIRE - Return information required to display an icon in the control panel.
          CPL_INQUIRE : begin
                             //  lParam2 is a pointer to a CPLINFO structure, so get a handle to it.
                             CPLInfo := pCPLINFO(lParam2);
                             //  Point the icon towards the icon handle obtained earlier.
                             CPLInfo^.idIcon := IconHandle;
                             //  The app name is defined in string resource 1 (see main.rc)
                             CPLInfo^.idName := 1;
                             //  The app description is defined in string resource 2 (see main.rc)
                             CPLInfo^.idInfo := 2;
                             //  Not used so set to 0
                             CPLInfo^.lData := 0;
                             //  Return zero to indicate success
                             result := 0;
                        end;
          //  CPL_DBLCLK - This occurs when our app is actually run.
          CPL_DBLCLK : begin
                            //  Call your dialog/modal form from here.
                            //  Note - the form must be modal
                            Path := GetRegStrValue(HKEY_CURRENT_USER,REGKey,'ADOAdminPath');
                            If Path = '' then
                               Path := ExtractFileDrive(FindWindowsDir) + 'Program Files\Common Files\ADOAdmin\';
                            Path := BackSlash(Path) + 'ADOAdmin.exe';
                            If FileExists(Path) then
                               StartProg(Path);
                            //  Return zero to indicate success
                            result := 0;
                       end;
          //  CPL_STOP - Called when application is de-initialised
          CPL_STOP : begin
                          //  Perform your cleanup code here.
                          //  Return zero to indicate success
                          result := 0;
                     end;
          //  CPL_EXIT - Control panel is exiting.
          CPL_EXIT : begin
                          //  Return zero to indicate success
                          result := 0;
                     end;
     else
         //  All other events, just return 0 (processed OK)
         result := 0;
     end;
end;

exports
       CPlApplet;

begin
end.
