(* NZCS_WIN16            : Compilation target is 16-bit Windows               *)
(* NZCS_WIN32            : Compilation target is 32-bit Windows               *)
(*                        See my web site in the Hints section for how to fix *)
(* NZCS_NO_COM_CLEANUP   : The version of the compiler being used does not    *)
(*                        require COM objects to be released; it is done      *)
(*                        automatically when they go "out of scope".          *)
(* NZCS_COMPILER_1       : Delphi 1.0 is the compiler.  Note that C++B 1.0    *)
(*                        does NOT cause this to be defined.  It is really    *)
(*                        the 2.0 compiler.                                   *)
(* NZCS_COMPILER_1_UP    : Delphi 1.0x or higher, or C++B 1.0x or higher is   *)
(*                        the compiler.                                       *)
(* NZCS_COMPILER_2       : Delphi 2.0x or C++B 1.0x is the compiler.          *)
(* NZCS_COMPILER_2_UP    : Delphi 2.0x or higher, or C++B 1.0x or higher is   *)
(*                        the compiler.                                       *)
(* NZCS_COMPILER_3       : Delphi 3.0x or C++B 3.0x is the compiler.          *)
(* NZCS_COMPILER_3_UP    : Delphi 3.0x or higher, or C++B 3.0x or higher is   *)
(*                        the compiler.                                       *)
(* NZCS_COMPILER_4       : Delphi 4.0x or C++B 4.0x is the compiler.          *)
(* NZCS_COMPILER_4_UP    : Delphi 4.0x or higher, or C++B 4.0x or higher is   *)
(*                        the compiler.                                       *)
(* NZCS_COMPILER_5       : Delphi 5.0x or C++B 5.0x is the compiler.          *)
(* NZCS_COMPILER_5_UP    : Delphi 5.0x or higher, or C++B 5.0x or higher is   *)
(*                        the compiler.                                       *)
(* NZCS_COMPILER_6       : Delphi 6.0x or C++B 6.0x is the compiler.          *)
(* NZCS_COMPILER_6_UP    : Delphi 6.0x or higher, or C++B 6.0x or higher is   *)
(*                        the compiler.                                       *)
(* NZCS_UNKNOWN_COMPILER : No sense could be made of the compiliation         *)
(*                        environment.                                        *)
(* NZCS_CPPB             : Any version of C++B is being used.                 *)
(* NZCS_CPPB_1           : C++B v1.0x is being used.                          *)
(* NZCS_CPPB_3           : C++B v3.0x is being used.                          *)
(* NZCS_CPPB_3_UP        : C++B v3.0x or higher is being used.                *)
(* NZCS_CPPB_4           : C++B v4.0x is being used.                          *)
(* NZCS_CPPB_4_UP        : C++B v4.0x or higher is being used.                *)
(* NZCS_CPPB_5           : C++B v5.0x is being used.                          *)
(* NZCS_CPPB_5_UP        : C++B v5.0x or higher is being used.                *)
(* NZCS_DELPHI           : Any version of Delphi is being used.               *)
(* NZCS_DELPHI_1         : Delphi v1.0x is being used.                        *)
(* NZCS_DELPHI_2         : Delphi v2.0x is being used.                        *)
(* NZCS_DELPHI_2_UP      : Delphi v2.0x or higher is being used.              *)
(* NZCS_DELPHI_3         : Delphi v3.0x is being used.                        *)
(* NZCS_DELPHI_3_UP      : Delphi v3.0x or higher is being used.              *)
(* NZCS_DELPHI_4         : Delphi v4.0x is being used.                        *)
(* NZCS_DELPHI_4_UP      : Delphi v4.0x or higher is being used.              *)
(* NZCS_DELPHI_5         : Delphi v5.0x is being used.                        *)
(* NZCS_DELPHI_5_UP      : Delphi v5.0x or higher is being used.              *)
(* NZCS_DELPHI_6         : Delphi v6.0x is being used.                        *)
(* NZCS_DELPHI_6_UP      : Delphi v6.0x or higher is being used.              *)
(******************************************************************************)


{ All components rely on complete boolean eval compiler directive set off. }
{$B-}

{$DEFINE DELPHI_ADOADMIN}

{$IFDEF WIN32}
  {$DEFINE NZCS_WIN32}
{$ELSE}
  {$DEFINE NZCS_WIN16}
{$ENDIF}

{$IFDEF VER140}
  {$DEFINE NZCS_COMPILER_6}
  {$IFDEF BCB}
    {$DEFINE NZCS_CPPB}
    {$DEFINE NZCS_CPPB_6}
  {$ELSE}
    {$DEFINE NZCS_DELPHI}
    {$DEFINE NZCS_DELPHI_6}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER130}
  {$DEFINE NZCS_COMPILER_5}
  {$IFDEF BCB}
    {$DEFINE NZCS_CPPB}
    {$DEFINE NZCS_CPPB_5}
  {$ELSE}
    {$DEFINE NZCS_DELPHI}
    {$DEFINE NZCS_DELPHI_5}
  {$ENDIF}
{$ENDIF}

{$IFDEF VER125}
  {$DEFINE NZCS_COMPILER_4}
  {$DEFINE NZCS_CPPB}
  {$DEFINE NZCS_CPPB_4}
{$ENDIF}

{$IFDEF VER120}
  {$DEFINE NZCS_COMPILER_4}
  {$DEFINE NZCS_DELPHI}
  {$DEFINE NZCS_DELPHI_4}
{$ENDIF}

{$IFDEF VER110}
  {$DEFINE NZCS_COMPILER_3}
  {$DEFINE NZCS_CPPB}
  {$DEFINE NZCS_CPPB_3}
{$ENDIF}

{$IFDEF VER100}
  {$DEFINE NZCS_COMPILER_3}
  {$DEFINE NZCS_DELPHI}
  {$DEFINE NZCS_DELPHI_3}
{$ENDIF}

{$IFDEF VER93}
  {$DEFINE NZCS_COMPILER_2}  { C++B v1 compiler is really v2 }
  {$DEFINE NZCS_CPPB}
  {$DEFINE NZCS_CPPB_1}
{$ENDIF}

{$IFDEF VER90}
  {$DEFINE NZCS_COMPILER_2}
  {$DEFINE NZCS_DELPHI}
  {$DEFINE NZCS_DELPHI_2}
{$ENDIF}

{$IFDEF VER80}
  {$DEFINE NZCS_COMPILER_1}
  {$DEFINE NZCS_DELPHI}
  {$DEFINE NZCS_DELPHI_1}
{$ENDIF}

{$IFNDEF NZCS_CPPB}
  {$IFNDEF NZCS_DELPHI}
    { Don't know what the hell it is.  Could be new version, or could be old BP. }
    {$DEFINE NZCS_UNKNOWN_COMPILER}
  {$ENDIF}
{$ENDIF}

{$IFDEF NZCS_COMPILER_1}
  {$DEFINE NZCS_COMPILER_1_UP}
{$ENDIF}

{$IFDEF NZCS_COMPILER_2}
  {$DEFINE NZCS_COMPILER_1_UP}
  {$DEFINE NZCS_COMPILER_2_UP}
{$ENDIF}

{$IFDEF NZCS_COMPILER_3}
  {$DEFINE NZCS_COMPILER_1_UP}
  {$DEFINE NZCS_COMPILER_2_UP}
  {$DEFINE NZCS_COMPILER_3_UP}
{$ENDIF}

{$IFDEF NZCS_COMPILER_4}
  {$DEFINE NZCS_COMPILER_1_UP}
  {$DEFINE NZCS_COMPILER_2_UP}
  {$DEFINE NZCS_COMPILER_3_UP}
  {$DEFINE NZCS_COMPILER_4_UP}
{$ENDIF}

{$IFDEF NZCS_COMPILER_5}
  {$DEFINE NZCS_COMPILER_1_UP}
  {$DEFINE NZCS_COMPILER_2_UP}
  {$DEFINE NZCS_COMPILER_3_UP}
  {$DEFINE NZCS_COMPILER_4_UP}
  {$DEFINE NZCS_COMPILER_5_UP}
{$ENDIF}

{$IFDEF NZCS_DELPHI_2}
  {$DEFINE NZCS_DELPHI_2_UP}
{$ENDIF}

{$IFDEF NZCS_DELPHI_3}
  {$DEFINE NZCS_DELPHI_2_UP}
  {$DEFINE NZCS_DELPHI_3_UP}
{$ENDIF}

{$IFDEF NZCS_DELPHI_4}
  {$DEFINE NZCS_DELPHI_2_UP}
  {$DEFINE NZCS_DELPHI_3_UP}
  {$DEFINE NZCS_DELPHI_4_UP}
{$ENDIF}

{$IFDEF NZCS_DELPHI_5}
  {$DEFINE NZCS_DELPHI_2_UP}
  {$DEFINE NZCS_DELPHI_3_UP}
  {$DEFINE NZCS_DELPHI_4_UP}
  {$DEFINE NZCS_DELPHI_5_UP}
{$ENDIF}

{$IFDEF NZCS_CPPB_3}
  {$DEFINE NZCS_CPPB_3_UP}
{$ENDIF}

{$IFDEF NZCS_CPPB_4}
  {$DEFINE NZCS_CPPB_3_UP}
  {$DEFINE NZCS_CPPB_4_UP}
{$ENDIF}

{$IFDEF NZCS_CPPB_5}
  {$DEFINE NZCS_CPPB_3_UP}
  {$DEFINE NZCS_CPPB_4_UP}
  {$DEFINE NZCS_CPPB_5_UP}
{$ENDIF}

{$IFDEF NZCS_CPPB_3_UP}
  // C++Builder requires this if you use Delphi components in run-time packages.
  {$ObjExportAll On}
{$ENDIF}

