unit NZCSComline;

interface

uses Windows, Sysutils;

var
   sParams      : PChar;

function aParamStr(Index: Integer): string;
function aParamCount: Integer;
function aFindCmdLineSwitch(const Switch: string; SwitchChars: TSysCharSet; IgnoreCase: Boolean): smallint;

implementation

function GetParamStr(P: PChar; var Param: string): PChar;
var
  Len: Integer;
  Buffer: array[0..4095] of Char;
begin
  while True do
  begin
    while (P[0] <> #0) and (P[0] <= ' ') do Inc(P);
    if (P[0] = '"') and (P[1] = '"') then Inc(P, 2) else Break;
  end;
  Len := 0;
  while (P[0] > ' ') and (Len < SizeOf(Buffer)) do
    if P[0] = '"' then
    begin
      Inc(P);
      while (P[0] <> #0) and (P[0] <> '"') do
      begin
        Buffer[Len] := P[0];
        Inc(Len);
        Inc(P);
      end;
      if P[0] <> #0 then Inc(P);
    end else
    begin
      Buffer[Len] := P[0];
      Inc(Len);
      Inc(P);
    end;
  SetString(Param, Buffer, Len);
  Result := P;
end;

function aParamCount: Integer;
var
  P: PChar;
  S: string;
begin
  P := GetParamStr(sParams, S);
  Result := 0;
  while True do
  begin
    P := GetParamStr(P, S);
    if S = '' then Break;
    Inc(Result);
  end;
end;

function aParamStr(Index: Integer): string;
var
  P: PChar;
  Buffer: array[0..260] of Char;
begin
  if Index = 0 then
    SetString(Result, Buffer, GetModuleFileName(0, Buffer, SizeOf(Buffer)))
  else
  begin
    P := sParams;
    while True do
    begin
      P := GetParamStr(P, Result);
      if (Index = 0) or (Result = '') then Break;
      Dec(Index);
    end;
  end;
end;

function aFindCmdLineSwitch(const Switch: string; SwitchChars: TSysCharSet; IgnoreCase: Boolean): Smallint;
var
  I: Integer;
  S: string;
begin
   result := -1;
   for I := 1 to aParamCount do begin
      S := aParamStr(I);
      if (SwitchChars = []) or (S[1] in SwitchChars) then begin
         if IgnoreCase then begin
            if (AnsiCompareText(Copy(S, 2, Maxint), Switch) = 0) then begin
               Result := I;
               break;
            end;
         end
         else begin
            if (AnsiCompareStr(Copy(S, 2, Maxint), Switch) = 0) then begin
               Result := I;
               break;
            end;
         end;
      end;
  end;
end;


end.
